/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.user.client.rpc;

/**
 * This interface controls how objects are encoded into a stream.
 * @skip
 */
public interface SerializationStreamObjectEncoder {
  /**
   * Get the string table associated with this encoder.
   * 
   * @return
   */
  StringTable getStringTable();

  /**
   * Mark the start of an instance. This method returns true if the method
   * instance has already been stored into the serialization stream. If the
   * object is already stored then no writeObject calls should be made.
   */
  boolean startInstance(SerializationStreamWriter stream, Object instance)
      throws SerializationException;

  /**
   * Mark the end of instance in the stream.
   */
  void endInstance(SerializationStreamWriter stream, Object instance);
}
