/*
 * Copyright 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.user.client.ui.impl;

import com.google.gwt.user.client.Element;

/**
 * Focusing DIVs on old versions of Mozilla/Gecko requires the use of the
 * MozUserFocus style, and does not support focus/blur/tabindex.
 */
public class FocusImplOldMoz extends FocusImpl {

  public native Element createFocusable() /*-{
    var e = $doc.createElement("DIV");
    e.style.MozUserFocus = 'normal';
    return e;
  }-*/;

  public void focus(Element elem) {
    // old versions of the gecko engine don't support 'blur()' on aribtrary
    // elements.
  }

  public void blur(Element elem) {
    // old versions of the gecko engine don't support 'blur()' on aribtrary
    // elements.
  }

  public void setTabIndex(Element elem, int index) {
    // old versions of the gecko engine don't support the tabIndex property
    // on arbitrary elements.
  }

  public int getTabIndex(Element elem) {
    // old versions of the gecko engine don't support the tabIndex property
    // on arbitrary elements.
    return -1;
  }
}
